<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Source Operands</TITLE>
<link href="suif1_29.html" rel=Next>
<link href="suif1_27.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_27.html">previous</A>, <A HREF="suif1_29.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC28" HREF="suif1_toc.html#TOC28">Source Operands</A></H3>
<P>
<A NAME="IDX152"></A>
<A NAME="IDX153"></A>

</P>
<P>
<A NAME="IDX154"></A>
<A NAME="IDX155"></A>
<A NAME="IDX156"></A>
Even though the base <CODE>instruction</CODE> class does not contain any
source operand fields, it does provide several methods to access the
source operands in derived classes.  First, the <CODE>num_srcs</CODE> method
returns the number of source operands in a particular instruction.  Once
you know the number of sources, you can access them by number.  This is
frequently useful when you need to visit all of the source operands
without concern for how they are used in the instruction.  The
<CODE>src_op</CODE> and <CODE>set_src_op</CODE> methods provide this access.  The
operands are numbered beginning from zero (like arrays in C).
Specifying an operand number that does not exist will cause an error.
Do not use these methods to access a particular operand field in an
instruction; the operand numbering used here is implementation-defined
and subject to change.

</P>
<P>
<A NAME="IDX157"></A>
<A NAME="IDX158"></A>
The <CODE>src_map</CODE> method provides an alternate way to visit all of the
source operands.  It applies a function that you specify to all of the
source operands.  This can be used to implement recursive descents of
expression trees by making the mapped function call <CODE>src_map</CODE> if
the operand is an instruction.  This is similar to what the
<CODE>instr_map</CODE> method in the <CODE>tree_instr</CODE> class does.
See section <A HREF="suif1_14.html#SEC14">Instruction Nodes</A>.  The mapped function must match the
<CODE>src_map_f</CODE> type which has three parameters: a pointer to the
instruction, a pointer to a copy of the operand, and a <CODE>void*</CODE>
value used to pass any other information needed by the function.  If the
function returns <CODE>TRUE</CODE>, the copy of the operand will be assigned
to the actual operand field within the instruction.  If it returns
<CODE>FALSE</CODE>, the source operand field is not modified.

</P>
<P>
<A NAME="IDX159"></A>
<A NAME="IDX160"></A>
The SUIF library requires that instruction pointers in operands be
consistent.  That is, a source operand may only point to an instruction
if the destination of that instruction points back to where the result
value is used.  Because of this, you cannot simply overwrite a source
operand that contains an instruction pointer.  Doing so would leave the
other instruction with an inconsistent destination operand.  Instead,
you must first use the source operand's <CODE>remove</CODE> method.  This
clears the instruction pointers in both the source and destination
operands.  If the source instruction was part of an expression tree
(i.e. it didn't have its own parent <CODE>tree_instr</CODE> node),
<CODE>remove</CODE> also clears its <CODE>parent</CODE> pointer by calling the
parent's <CODE>remove_instr</CODE> method (see section <A HREF="suif1_14.html#SEC14">Instruction Nodes</A>).  If the
source operand is not an instruction, the <CODE>remove</CODE> method does
nothing so it is always safe to use it.  The <CODE>instruction</CODE> class
also has a <CODE>remove</CODE> method which does the same thing.

</P>
<P>
As an example, the following code clears all of the source operands in
an instruction:

</P>

<PRE>
for (int n = 0; n &#60; i-&#62;num_srcs(); n++) {
    i-&#62;src_op(n).remove();
    i-&#62;set_src_op(n, operand());
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_27.html">previous</A>, <A HREF="suif1_29.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
